' ********************************************************************
' Example2:
'    Two-way client/server communication
'    First start server.vbs on server, then start client.vbs on client
' Note:
'    Substitute 127.0.0.1 in Connect function on client if server process is running 
'    on another machine.
' ********************************************************************

' Constants: Connection states
Const asCONN_DISCONNECTED=1
Const asCONN_LISTENING=2
Const asCONN_CONNECTED=3

' Constants: Some Error codes
Const asERR_SUCCESS=0
Const asERR_INVALIDPARAMETER=1
Const asERR_CREATETHREADFAILED=2
Const asERR_EVALUATIONEXPIRED=3
Const asERR_INVALIDLICENSE=4

' Constants: Protocols
Const asPROTOCOL_RAW=1
Const asPROTOCOL_TELNET=2

' Create a socket instance
Set asObj = CreateObject("ActivXperts.Socket")
asObj.Protocol = asPROTOCOL_RAW

' Write some information to console
WScript.Echo "ActivSocket " & asObj.Version & " demo."
WScript.Echo "Expiration date: " & asObj.ExpirationDate & vbCrLf

' Make a connection to port 1500 on remote server
asObj.Connect "127.0.0.1", 1500
Wscript.Echo "Connect: result = " & asObj.LastError
If asObj.LastError = 11001 Then
WScript.Echo "Error 11001: Specify a valid hostname-parameter in the Connect-method."
End If
If asObj.LastError = asERR_SUCCESS Then

    ' YES, connection established.
    WScript.Echo "Connection established" & vbCrLf

    str = ""
    numMessage = 0

    Do while asObj.ConnectionState = asCONN_CONNECTED and numMessage < 5
        numMessage = numMessage + 1
        If numMessage = 5 Then
            asObj.SendData "Quit"
        Else
            asObj.SendData "Client Message " & numMessage
        End If
        Wscript.Echo "SendData: result = " & asObj.LastError
        asObj.Sleep 1000
        If asObj.HasData Then
            str = asObj.ReceiveData
            WScript.Echo "Received: " & str
        End If
    Loop

    asObj.Sleep 1000

' And finally, disconnect
    asObj.Disconnect
End If
