' ********************************************************************
' Example2:
'    Two-way client/server communication
'    First start server.vbs on server, then start client.vbs on client
' ********************************************************************

' Constants: Connection states
Const asCONN_DISCONNECTED=1
Const asCONN_LISTENING=2
Const asCONN_CONNECTED=3

' Constants: Some Error codes
Const asERR_SUCCESS=0
Const asERR_INVALIDPARAMETER=1
Const asERR_CREATETHREADFAILED=2
Const asERR_EVALUATIONEXPIRED=3
Const asERR_INVALIDLICENSE=4

' Constants: Protocols
Const asPROTOCOL_RAW=1
Const asPROTOCOL_TELNET=2

' Create a socket instance
Set asObj = CreateObject("ActivXperts.Socket")
asObj.Protocol = asPROTOCOL_RAW

' Write some information to console
WScript.Echo "ActivSocket " & asObj.Version & " demo."
WScript.Echo "Expiration date: " & asObj.ExpirationDate & vbCrLf

' Try to listen for a connection on port 1500 on this machine
asObj.StartListening 1500
WScript.Echo "StartListening: result = " & asObj.LastError

If asObj.LastError = asERR_SUCCESS Then

    ' Wait for a connection on port 1500 on this machine now...
    WScript.Echo "Waiting for a connection now..."

    Do While asObj.ConnectionState = asCONN_LISTENING
        asObj.Sleep 1000
    Loop

    If asObj.ConnectionState = asCONN_CONNECTED Then
        ' YES, connection established
        WScript.Echo "Connection established" & vbCrLf

        Do While asObj.ConnectionState = asCONN_CONNECTED and str <> "Quit"

            asObj.Sleep 1000
            If asObj.HasData Then
                str = asObj.ReceiveData
                WScript.Echo "Received: " & str
                numMessages = numMessages + 1
                asObj.SendData "Server received message at " & Time()
            End If
        Loop

        ' And finally, disconnect
        asObj.Disconnect
    End If
End If
